#include<iostream>
#include<stdlib.h>
#include<algorithm>

using namespace std;

long long n,m,pok1,pok2,mini,tren,pocetak,kraj;
long long prolaz[10005],a[200005];
long long kon=1000000000000000000;

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for(int i=0;i<n;i++)
        cin >> a[i];
    for(int i=0;i<n;i++)
        a[i+n]=a[i]-m;
    sort(a,a+2*n);
    pok1=0,pok2=n-1;
    for(int i=0;i<=n;i++)
        if(a[pok2]-a[pok1]>a[i+n-1]-a[i])
            pok1=i,pok2=i+n-1;
    mini=a[pok2]-a[pok1];
    for(int i=0;i<=n;i++)
    {
        if(a[i+n-1]-a[i]==mini)
        {
            tren=0;
            for(int p=0;p<m;p++)
                prolaz[i]=0;
            for(int p=0;p<n;p++)
            {
                if(a[i+p]>0)
                {
                    for(int j=0;j<a[i+p];j++)
                        prolaz[j]++;
                }
                else
                {
                    for(int j=m-1;j>m+a[i+p]-1;j--)
                        prolaz[j]++;
                }
            }
            for(int j=0;j<m;j++)
                tren+=prolaz[j]*(n-prolaz[j]);
            kon=min(kon,tren);
        }
    }
    cout << kon << endl;
}